function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { renderless, api } from "@xmweb-ui/vue-renderless/date-picker-mobile/vue";
import { defineComponent, $prefix, $props, setup as _setup } from "@xmweb-ui/vue-common";
import Button from "@xmweb-ui/vue-button";
import TimePickerMobile from "@xmweb-ui/vue-time-picker-mobile";
import ActionSheet from "@xmweb-ui/vue-action-sheet";
import { openBlock, createElementBlock, renderSlot, createTextVNode, toDisplayString, resolveComponent, createVNode, withCtx, createElementVNode, Fragment, renderList, normalizeClass, withModifiers, createCommentVNode } from "vue";
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it)
    return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it)
      o = it;
    var i = 0;
    return function() {
      if (i >= o.length)
        return { done: true };
      return { done: false, value: o[i++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var _sfc_main$1 = {
  inheritAttrs: false,
  components: {},
  props: {
    data: Object
  }
};
var _hoisted_1$1 = {
  class: "w-full w-full flex"
};
function _sfc_render$1(_ctx, _cache, $props2, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", _hoisted_1$1, [renderSlot(_ctx.$slots, "default", {
    data: $props2.data
  }, function() {
    return [createTextVNode(
      toDisplayString($props2.data.day),
      1
      /* TEXT */
    )];
  })]);
}
var Option = /* @__PURE__ */ _export_sfc(_sfc_main$1, [["render", _sfc_render$1]]);
var _sfc_main = defineComponent({
  name: $prefix + "DatePickerMobile",
  components: {
    XmOption: Option,
    XmActionSheet: ActionSheet,
    XmTimePickerMobile: TimePickerMobile,
    XmButton: Button
  },
  props: _extends({}, $props, {
    modelValue: [Number, String, Array, Date],
    visible: {
      type: Boolean,
      default: false
    },
    title: String,
    type: {
      type: String,
      default: "date"
    }
  }),
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var _hoisted_1 = {
  "data-tag": "xm-date-picker-mobile"
};
var _hoisted_2 = {
  "data-tag": "xm-date-picker-inner",
  class: /* @__PURE__ */ normalizeClass(["flex flex-col flex-auto h-full"])
};
var _hoisted_3 = {
  "data-tag": "date-picker-header",
  class: "flex leading-6 py-2.5 px-4 text-sm items-center text-center border-b border-color-bg-4 shadow-sm"
};
var _hoisted_4 = {
  ref: "datePickerBody",
  "data-tag": "date-picker-body",
  class: "flex-auto overflow-auto px-4 scrollbar-size-0"
};
var _hoisted_5 = {
  class: "text-xl leading-7"
};
var _hoisted_6 = {
  class: "text-center leading-9 text-xs font-medium"
};
var _hoisted_7 = ["onClick"];
var _hoisted_8 = {
  "data-tag": "date-picker-footer",
  class: "flex flex-col items-center justify-center p-4 border-t border-color-bg-4 shadow-sm"
};
var _hoisted_9 = {
  key: 0,
  "data-tag": "rang-box",
  class: "w-full"
};
var _hoisted_10 = {
  class: "w-full flex mb-4 leading-6 text-base text-center"
};
var _hoisted_11 = {
  class: "min-w-[8rem]"
};
var _hoisted_12 = {
  class: "flex-auto min-w-[1rem]"
};
var _hoisted_13 = {
  key: 0,
  class: "h-9 h-9 border-l-0.5 inline-block rotate-45 relative top-6 border-color-bg-2"
};
var _hoisted_14 = {
  class: "min-w-[8rem]"
};
var _hoisted_15 = {
  key: 0,
  class: "text-color-icon-placeholder"
};
var _hoisted_16 = {
  key: 1
};
var _hoisted_17 = {
  key: 0,
  class: "w-full h-9 flex mb-4 leading-9 text-base text-center"
};
var _hoisted_18 = /* @__PURE__ */ createElementVNode(
  "div",
  {
    class: "flex-auto min-w-[1rem]"
  },
  null,
  -1
  /* HOISTED */
);
var _hoisted_19 = {
  key: 1,
  "data-tag": "datetime-box",
  class: "w-full"
};
var _hoisted_20 = {
  class: "w-full flex mb-4 leading-6 text-base text-center"
};
var _hoisted_21 = {
  class: "min-w-[8rem]"
};
var _hoisted_22 = /* @__PURE__ */ createElementVNode(
  "div",
  {
    class: "flex-auto min-w-[1rem]"
  },
  null,
  -1
  /* HOISTED */
);
var _hoisted_23 = {
  class: "w-full text-center"
};
function _sfc_render(_ctx, _cache, $props2, $setup, $data, $options) {
  var _component_xm_option = resolveComponent("xm-option");
  var _component_xm_button = resolveComponent("xm-button");
  var _component_xm_action_sheet = resolveComponent("xm-action-sheet");
  var _component_xm_time_picker_mobile = resolveComponent("xm-time-picker-mobile");
  return openBlock(), createElementBlock("div", _hoisted_1, [createVNode(_component_xm_action_sheet, {
    title: _ctx.title,
    "custom-class": "h-full max-h-[100%] rounded-none",
    visible: _ctx.visible,
    "onUpdate:visible": _cache[3] || (_cache[3] = function($event) {
      return _ctx.$emit("update:visible", $event);
    })
  }, {
    default: withCtx(function() {
      return [createElementVNode("div", _hoisted_2, [createElementVNode("div", _hoisted_3, [(openBlock(), createElementBlock(
        Fragment,
        null,
        renderList(7, function(item, index) {
          return createElementVNode(
            "div",
            {
              key: index,
              class: "flex-1"
            },
            toDisplayString(_ctx.t("ui.calendarBar.week." + index)),
            1
            /* TEXT */
          );
        }),
        64
        /* STABLE_FRAGMENT */
      ))]), createElementVNode(
        "div",
        _hoisted_4,
        [(openBlock(true), createElementBlock(
          Fragment,
          null,
          renderList(_ctx.state.months, function(yearMonth) {
            return openBlock(), createElementBlock("div", {
              key: yearMonth,
              class: "mt-4"
            }, [createElementVNode(
              "div",
              _hoisted_5,
              toDisplayString(yearMonth.replace("/", "年") + "月"),
              1
              /* TEXT */
            ), createElementVNode("div", _hoisted_6, [(openBlock(true), createElementBlock(
              Fragment,
              null,
              renderList(_ctx.getWeeksByMonth(yearMonth), function(item, week) {
                return openBlock(), createElementBlock("div", {
                  key: week,
                  class: normalizeClass(["flex mt-2"])
                }, [(openBlock(), createElementBlock(
                  Fragment,
                  null,
                  renderList(7, function(item2, index) {
                    return createElementVNode("div", {
                      key: index,
                      class: normalizeClass(["flex-1 h-9 cursor-pointer", {
                        "text-color-text-placeholder": index === 0 || index === 6
                      }]),
                      onClick: withModifiers(function($event) {
                        return _ctx.selectOption({
                          yearMonth,
                          index: index + week * 7
                        });
                      }, ["stop"])
                    }, [createVNode(_component_xm_option, {
                      data: _ctx.getDate({
                        yearMonth,
                        index: index + week * 7
                      })
                    }, {
                      default: withCtx(function(_ref) {
                        var data = _ref.data;
                        return [createElementVNode(
                          "div",
                          {
                            class: normalizeClass(["flex-1", {
                              "bg-color-info-primary-subtler": ["end", "inner"].includes(_ctx.getSelectedPosition(data.date)) && _ctx.state.date.length === 2
                            }])
                          },
                          null,
                          2
                          /* CLASS */
                        ), createElementVNode(
                          "div",
                          {
                            class: normalizeClass(["w-9 h-9", {
                              "bg-color-info-primary-subtler": ["inner"].includes(_ctx.getSelectedPosition(data.date))
                            }, {
                              "bg-color-brand text-white": ["start", "end"].includes(_ctx.getSelectedPosition(data.date))
                            }])
                          },
                          [renderSlot(_ctx.$slots, "default", {
                            data
                          }, function() {
                            return [createTextVNode(
                              toDisplayString(data.day),
                              1
                              /* TEXT */
                            )];
                          })],
                          2
                          /* CLASS */
                        ), createElementVNode(
                          "div",
                          {
                            class: normalizeClass(["flex-1", {
                              "bg-color-info-primary-subtler": ["start", "inner"].includes(_ctx.getSelectedPosition(data.date)) && _ctx.state.date.length === 2
                            }])
                          },
                          null,
                          2
                          /* CLASS */
                        )];
                      }),
                      _: 2
                      /* DYNAMIC */
                    }, 1032, ["data"])], 10, _hoisted_7);
                  }),
                  64
                  /* STABLE_FRAGMENT */
                ))]);
              }),
              128
              /* KEYED_FRAGMENT */
            ))])]);
          }),
          128
          /* KEYED_FRAGMENT */
        ))],
        512
        /* NEED_PATCH */
      ), createElementVNode("div", _hoisted_8, [["datetimerange", "daterange"].includes(_ctx.type) && _ctx.state.date.length ? (openBlock(), createElementBlock("div", _hoisted_9, [createElementVNode("div", _hoisted_10, [createElementVNode(
        "div",
        _hoisted_11,
        toDisplayString(_ctx.getFormatDate(_ctx.state.date[0], "年", "月", "日")),
        1
        /* TEXT */
      ), createElementVNode("div", _hoisted_12, [["datetimerange"].includes(_ctx.type) ? (openBlock(), createElementBlock("div", _hoisted_13)) : createCommentVNode("v-if", true)]), createElementVNode("div", _hoisted_14, [_ctx.state.btnDisabled ? (openBlock(), createElementBlock("span", _hoisted_15, "结束时间")) : (openBlock(), createElementBlock(
        "span",
        _hoisted_16,
        toDisplayString(_ctx.getFormatDate(_ctx.state.date[1], "年", "月", "日")),
        1
        /* TEXT */
      ))])]), _ctx.type === "datetimerange" ? (openBlock(), createElementBlock("div", _hoisted_17, [createElementVNode(
        "div",
        {
          class: "w-32 bg-color-bg-2",
          onClick: _cache[0] || (_cache[0] = withModifiers(function($event) {
            return _ctx.timeToggle(0);
          }, ["stop"]))
        },
        toDisplayString(_ctx.state.timeList[0].join(":")),
        1
        /* TEXT */
      ), _hoisted_18, createElementVNode(
        "div",
        {
          class: "w-32 bg-color-bg-2",
          onClick: _cache[1] || (_cache[1] = withModifiers(function($event) {
            return _ctx.timeToggle(1);
          }, ["stop"]))
        },
        toDisplayString(_ctx.state.timeList[1].join(":")),
        1
        /* TEXT */
      )])) : createCommentVNode("v-if", true)])) : createCommentVNode("v-if", true), ["datetime"].includes(_ctx.type) && _ctx.state.date ? (openBlock(), createElementBlock("div", _hoisted_19, [createElementVNode("div", _hoisted_20, [createElementVNode(
        "div",
        _hoisted_21,
        toDisplayString(_ctx.getFormatDate(_ctx.state.date, "年", "月", "日")),
        1
        /* TEXT */
      ), _hoisted_22, createElementVNode(
        "div",
        {
          class: "w-32 bg-color-bg-2",
          onClick: _cache[2] || (_cache[2] = withModifiers(function($event) {
            return _ctx.timeToggle(0);
          }, ["stop"]))
        },
        toDisplayString(_ctx.state.timeList[0].join(":")),
        1
        /* TEXT */
      )])])) : createCommentVNode("v-if", true), createElementVNode("div", _hoisted_23, [createVNode(_component_xm_button, {
        xm_mode: "mobile-first",
        "button-class": "w-full",
        disabled: _ctx.state.btnDisabled,
        type: "primary",
        size: "medium",
        "reset-time": 0,
        onClick: _ctx.confirm
      }, {
        default: withCtx(function() {
          return [createTextVNode(
            toDisplayString(_ctx.t("ui.button.confirm")),
            1
            /* TEXT */
          )];
        }),
        _: 1
        /* STABLE */
      }, 8, ["disabled", "onClick"])])])])];
    }),
    _: 3
    /* FORWARDED */
  }, 8, ["title", "visible"]), createVNode(_component_xm_time_picker_mobile, {
    modelValue: _ctx.state.time,
    "onUpdate:modelValue": _cache[4] || (_cache[4] = function($event) {
      return _ctx.state.time = $event;
    }),
    title: "时间选择",
    visible: _ctx.state.timeVisible,
    "onUpdate:visible": _cache[5] || (_cache[5] = function($event) {
      return _ctx.state.timeVisible = $event;
    }),
    onConfirm: _ctx.timeConfirm
  }, null, 8, ["modelValue", "visible", "onConfirm"])]);
}
var DatePickerMobile = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
var version = "3.8.0";
DatePickerMobile.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
DatePickerMobile.install = function(Vue) {
  Vue.component(DatePickerMobile.name, DatePickerMobile);
};
DatePickerMobile.version = version;
export {
  DatePickerMobile as default
};
